require ('selection_with_upbeat')
require ('make_wave')
require ('phase_shift')

function main ()
  local vb = renoise.ViewBuilder()
  -- selection length default
  local get_x_beat = 1
  local get_x_frame =168
  -- significant figure
  local sig = 6

  -- Add New button
  local addnew_bt=    
  vb:button
  {
    width = 80,
    text = " Add New ",
    tooltip =
    "Copy the selection range into new sample.",
    
    notifier =
    function()
      set_new_with_upbeat (0)
    end,
  }
-- set end
  local setend_txt =
  vb:text
  {
    text = "selection length:"
  }
  
  --set end with frame
  local setend_frame_in =
  vb:row
  { 
    vb:textfield
    { 
      id = "set_end_val_frame",
      width = 160,
      text = "168 ",
      tooltip = 
      "Input the number or the formula that represents\n the selection range. \n e.g.\n  '4.5' , '1/4' , '16*3/4'.", 
      
      notifier =
      function(x)       
        if pcall(loadstring('return '..x))==false
          or
          loadstring("return "..x)()==nil
          or
          loadstring("return "..x)()<=0
        then
          renoise.app():show_error(
            [[Enter a number greater than zero,
            or a numerical formula.
            e.g.
            '2.5' , '1/4' , '(32-18)/3'              
            
            ]])
        else get_x_frame=loadstring("return "..x)()
        end
      end
    },
    
    vb:text
    {
      text = "sample"
    },
    vb:button
    {
      width = 6,
      text = "Get",
      tooltip =
      "Get the length of the selection range ,measured in sample.",
      
      notifier = 
      function()
        local val = round(selection_frames(),sig)
        vb.views.set_end_val_frame.text = tostring(val)
        get_x_frame = tonumber(val)
      end,
    },
  }
  
  local setend_frame_bt =
  vb:button
  {
    width = 80,
    text = " Set End ",
    tooltip =
    "Reset the selection end point.",
    
    notifier =
    function()
      set_end_point_with_frame (get_x_frame)
    end
  }

  
  -- set end with beat
  local setend_beat_in =
  vb:row
  { 
    vb:textfield
    { 
      id = "set_end_val_beat",
      width = 160,
      text = "1 ",
      tooltip = 
      "Input the number or the formula that represents\n the selection range. \n e.g.\n  '4.5' , '1/4' , '16*3/4'.", 
      
      notifier =
      function(x)       
        if pcall(loadstring('return '..x))==false
          or
          loadstring("return "..x)()==nil
          or
          loadstring("return "..x)()<=0
        then
          renoise.app():show_error(
            [[Enter a number greater than zero,
            or a numerical formula.
            e.g.
            '2.5' , '1/4' , '(32-18)/3'              
            
            ]])
        else get_x_beat=loadstring("return "..x)()
        end
      end
    },
    
    vb:text
    {
      text = "beat"
    },
    vb:button
    {
      width = 6,
      text = "Get",
      tooltip =
      "Get the length of the selection range ,measured in beats.",
      
      notifier = 
      function()
        local val = round(selection2beat (),sig)
        vb.views.set_end_val_beat.text = tostring(val)
        get_x_beat = tonumber(val)
      end,
    },
  }
  
  local setend_beat_bt =
  vb:button
  {
    width = 80,
    text = " Set End ",
    tooltip =
    "Reset the selection end point.",
    
    notifier =
    function()
      set_end_point (beat_orgn(get_x_beat))
    end
  }
  
  -- Insert silence 
  local insert_bt =    
    vb:button
    { 
      width = 80,
      text = " Insert ",
      tooltip =
      "Insert silence, \nits length is same as the selection range.",
      
      notifier =
      function ()  
        sweep_ins()
      end,
    }
  -- sync_del
  local del_bt=    
    vb:button
    {
      width = 80,
      text = " Delete ",
      tooltip =
      "Clear the selection range.",
      
      notifier = 
      function()
        sync_del()
      end,          
    }
  
  --help
  local help =
  vb:button
  {
    width = 6,
    text = ("?"),
    notifier = 
    function()
        renoise.app():show_message(
          
          " For sample offset etc.,set the selection range and input some value measured in beats(or samples). \n If the total length protrudes from the original sample,\n this tool automatically inserts  silence.\n According to the length, this tries to change the sync value (when beatsync on).")
        
    end
  }      
  -- making waves
  local sin_2pi =    
  vb:button
  {
    width = 50,
    bitmap = "images/wave-sine2.bmp",
    tooltip =
    "Draw sin wave.",
    
    notifier =
    function()
      make_wave(sin_2pi_fn)
    end,
  }
  
  local sin_pi =    
  vb:button
  {
    width = 50,
    bitmap = "images/wave-sine.bmp",
    tooltip =
    "Draw sin wave.",
    
    notifier =
    function()
      make_wave(sin_pi_fn)
    end,
  }

  local saw =    
  vb:button
  {
    width = 50,
    bitmap = "images/wave-saw.bmp",
    tooltip =
    "Draw saw wave.",
    
    notifier =
    function()
      make_wave(saw_fn)
    end,
  }

  local square =    
  vb:button
  {
    width = 50,
    bitmap = "images/wave-square.bmp",
    tooltip =
    "Draw square wave.",
    
    notifier =
    function()
      make_wave(square_fn)
    end,
  }

  local triangle =    
  vb:button
  {
    width = 50,
    bitmap = "images/wave-tri.bmp",
    tooltip =
    "Draw triangle wave.",
    
    notifier =
    function()
      make_wave(triangle_fn)
    end,
  }

  
  local white_noise =    
  vb:button
  {
    width = 50,
    bitmap = "images/wave-noise.bmp",
    tooltip =
    "White noise",
    
    notifier =
    function()
      make_wave(white_noise_fn)
    end,
  }
--[[
  local pink_noise =    
  vb:button
  {
    width = 80,
    text = " Pink noise ",
    tooltip =
    "White noise",
    
    notifier =
    function()
      make_wave(pink_noise_fn)
    end,
  }
--]]

  local phase_shift_1on12_plus =    
  vb:button
  {
    width = 75,
    bitmap = "images/shift-plus12.bmp",
    tooltip =
    "Phase shift +1/12",
    
    notifier =
    function()
      phase_shift_with_ratio (1/12)
    end,
  }
  
  local phase_shift_1on12_minus =    
  vb:button
  {
    width = 75,
    bitmap = "images/shift-minus12.bmp",
    tooltip =
    "Phase shift -1/12",
    
    notifier =
    function()
      phase_shift_with_ratio (-1/12)
    end,
  }  


  local phase_shift_fine_plus =    
  vb:button
  {
    width = 75,
    bitmap = "images/shift-plus1.bmp",
    tooltip =
    "Phase shift +1sample",
    
    notifier =
    function()
      phase_shift_fine (1)
    end,
  }
    

  local phase_shift_fine_minus =    
  vb:button
  {
    width = 75,
    bitmap = "images/shift-minus1.bmp",
    tooltip =
    "Phase shift -1sample",
    
    notifier =
    function()
      phase_shift_fine (-1)
    end,
  }

  
  local fade_center_7on8 =    
  vb:button
  {
    width = 75,
    bitmap = "images/center-fade.bmp",
    tooltip =
    "Fade center 7/8.",
    
    notifier =
    function()
      set_fade(center_7on8_fn)
    end,
  }
  
  local fade_center_9on8 =    
  vb:button
  {
    width = 75,
    bitmap = "images/center-amplify.bmp",
    tooltip =
    "Amplify center 9/8.",
    
    notifier =
    function()
      set_fade(center_9on8_fn)
    end,
  }

  local multiply_11on12 =    
  vb:button
  {
    width = 75,
    bitmap = "images/whole-fade.bmp",
    tooltip =
    " multiply 11/12.",
    
    notifier =
    function()
      set_fade(multiply_11on12_fn)
    end,
  }
  
  local multiply_13on12 =    
  vb:button
  {
    width = 75,
    bitmap = "images/whole-amplify.bmp",
    tooltip =
    " multiply 13/12.",
    
    notifier =
    function()
      set_fade(multiply_13on12_fn)
    end,
  }
  
  local fade_with_sin =    
  vb:button
  {
    width = 80,
    text = " Fade with sin ",
    tooltip =
    "Fade witn sin",
    
    notifier =
    function()
      set_fade(sin_2pi_fn)
    end,
  }
  
  local fade_with_saw =    
  vb:button
  {
    width = 80,
    text = " Fade with saw ",
    tooltip =
    "Fade witn saw",
    
    notifier =
    function()
      set_fade(saw_fn)
    end,
  }

    local fade_with_square =    
  vb:button
  {
    width = 80,
    text = " Fade with square ",
    tooltip =
    "Fade witn square",
    
    notifier =
    function()
      set_fade(square_fn)
    end,
  }

  local fade_with_triangle =    
  vb:button
  {
    width = 80,
    text = " Fade with triangle ",
    tooltip =
    "Fade witn triangle",
    
    notifier =
    function()
      set_fade(triangle_fn)
    end,
  }


  
  local s1,s2,s3,s4,s5,s6,s7,s8,s9
  s1 = vb:column{setend_txt,setend_frame_in,setend_frame_bt,margin=4}
  s2 = vb:column{setend_beat_in,setend_beat_bt,margin=4}  
  s3 = vb:row{insert_bt,del_bt,margin = 4,}
  s4 = vb:row{sin_2pi,sin_pi,saw,square,triangle,white_noise,margin = 4}
  s5 = vb:row{phase_shift_1on12_plus,phase_shift_1on12_minus,
    phase_shift_fine_plus,phase_shift_fine_minus,margin = 4}
  s6 = vb:row{fade_center_7on8,fade_center_9on8,margin = 4}
  s7 = vb:row{multiply_11on12,multiply_13on12,margin = 4}  
  s8 = vb:row{fade_with_sin,fade_with_saw,fade_with_square,fade_with_triangle,margin = 4}
  s9 = vb:row{addnew_bt,help,margin = 4}
  
  local dialog_content = vb:column{s1,s2,s3,s4,s5,s6,s7,s8,s9,margin=4}
  renoise.app():show_custom_dialog("Selection reset" , dialog_content)
end

--[
renoise.tool():add_menu_entry {
  name = "Sample Editor:Selection reset ...",
  invoke = function() 
    main()
  end
}
--]]
