require ('globals')

-- いらない機能がついてる分、長い。

-- init sample settings
function get_init_env()
  init_inst = renoise.song().selected_instrument
  init_sample_index = renoise.song().selected_sample_index
  init_sample = renoise.song().selected_sample
  if init_sample ~= nil
  then
    init_buffer = renoise.song().selected_sample.sample_buffer
  else return nil
  end
  
  if init_buffer == nil or
    init_buffer.has_sample_data ~= true
  then
    renoise.app():show_error(" No sample data.")
    return nil
  end

  if
    #(renoise.song().selected_sample.slice_markers) >1
    then is_not_sliced = false
    else is_not_sliced = true
    end  
  
  init_sample_rate =
       init_buffer.sample_rate
  init_bit_depth =
       init_buffer.bit_depth
  init_number_of_channels =
  init_buffer.number_of_channels
  init_number_of_frames =
  init_buffer.number_of_frames

  init_interpolation_mode = init_sample.interpolation_mode
  init_new_note_action = init_sample.new_note_action
  init_autoseek = init_sample.autoseek
  init_autofade = init_sample.autofade
  init_panning = init_sample.panning
  init_volume = init_sample.volume
  init_loop_mode = init_sample.loop_mode
  init_loop_release = init_sample.loop_release
  
  init_sync_enabled = init_sample.beat_sync_enabled
  init_sync_lines = init_sample.beat_sync_lines

  init_sample_name = init_sample.name
  init_loop_start = init_sample.loop_start
  init_loop_end = init_sample.loop_end  
  init_transpose = init_sample.transpose
  init_fine_tune = init_sample.fine_tune

  selection_start =
          init_buffer.selection_start
  selection_end =
          init_buffer.selection_end
  bpm = renoise.song().transport.bpm
  lpb = renoise.song().transport.lpb
  return true
end

function has_sample_ok ()
  if init_buffer == nil or
    init_buffer.has_sample_data ~= true
    then
      renoise.app():show_error(" No sample data.")
      return nil
      else return true
      end
end

function not_sliced_ok ()
  if is_not_sliced == false
    then
    renoise.app():show_error(
               [[Sorry, sliced sample cannot be modified]])
    else return true
    end
end


-- new sample settings
function get_new_env()
  has_sample_ok ()
  init_inst:insert_sample_at(init_sample_index +1)
  new_sample =
          init_inst.samples[init_sample_index +1]
          
  new_sample.beat_sync_enabled =  init_sync_enabled
  --  new_sample.beat_sync_lines =  init_sync_lines

  new_sample.transpose = init_transpose
  new_sample.fine_tune = init_fine_tune
  new_sample.name = init_sample_name

  new_sample.interpolation_mode = init_interpolation_mode
  new_sample.new_note_action = init_new_note_action
  new_sample.autoseek = init_autoseek
  new_sample.autofade = init_autofade
  new_sample.panning = init_panning
  new_sample.volume = init_volume
  new_sample.loop_mode = init_loop_mode
  new_sample.loop_release = init_loop_release

  new_buffer = new_sample.sample_buffer
  
end


-- http://lua-users.org/wiki/SimpleRound
function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end


-- transposeの計算
function beat_unit_with_base_tune ()
--  get_init_env()
  local bn = init_transpose
  local ft = init_fine_tune

  if
    (bn == 0 and ft == 0) or
    init_sync_enabled == true
  then return 1
  else return
  math.pow ((1/2),(bn-(ft/128))/12)
  end
end


function beat_unit_with_sync ()
   get_init_env()
           
   if init_sync_enabled == false
   then return 1
   else
     return
     (init_number_of_frames * (lpb / init_sync_lines))/
     ((1 / bpm * 60) * init_sample_rate)
   end
end

function beat_orgn (beat)
  get_init_env()
  return
  beat * beat_unit_with_sync () * beat_unit_with_base_tune ()
end
----------------------------------

function frames_per_xbeat (beat)
  bpm = renoise.song().transport.bpm
  local seconds_per_beat = 1 / bpm * 60
  return round((seconds_per_beat * init_sample_rate * beat))
end

function selection2beat ()
   local t = get_init_env()
  if t ~= true then return 0
  end
   local val
     val = ((selection_end - selection_start +1) /
     ((1 / bpm * 60) * init_sample_rate)) /
      (beat_unit_with_sync () * beat_unit_with_base_tune ())
   return val
end

-- upbeatの始点の、現サンプル始まりを０とした時の位置
function upbeat_start_point(upbeat)
  selection_start =
          init_buffer.selection_start
  local s = (selection_start -1)
            - frames_per_xbeat(upbeat)
  if s >= 0 then
  return s+1
  else
  return s
  end
end

-- upbeat付Frame数の計算
function frames_with_upbeat(upbeat)
  selection_start =
          init_buffer.selection_start
  selection_end =
          init_buffer.selection_end
  return
  frames_per_xbeat (upbeat)
  + selection_end
  - selection_start + 1
end


function create_new (num_frames)
--  get_init_env()
--  init_inst:insert_sample_at(init_sample_index+1)
  get_new_env()

  local new_sync_val =
          init_sync_lines * (num_frames/init_number_of_frames) 
  if init_sync_enabled == false or new_sync_val > 256 
    then
      new_sample.beat_sync_lines = init_sync_lines
    else
      new_sample.beat_sync_lines = new_sync_val
  end 

  new_buffer:create_sample_data(
                 init_sample_rate,init_bit_depth,init_number_of_channels
                 , num_frames)
end


-- 下のset_new_with_upbeat での Loop位置再計算。
function set_new_loop_replace (upbeat)
  
  local ubf = frames_per_xbeat (upbeat)
  local new_loop_start, new_loop_end
  
  if
    init_loop_end > selection_end and
    init_loop_start > selection_start and
    init_loop_start <= selection_end
    then
      new_loop_start =
      ubf + (init_loop_start - selection_start) +1
      new_loop_end =
      ubf + (selection_end - selection_start) +1      
    elseif
      init_loop_end <= selection_end and
      init_loop_start >= selection_start
      then
        new_loop_start =
        ubf + (init_loop_start - selection_start) + 1
        new_loop_end =
        ubf + (init_loop_end - selection_start) + 1
    elseif
      init_loop_end < selection_end and
      init_loop_start < selection_start and
      selection_start - init_loop_start < ubf
      then
        new_loop_start =
        ubf - (selection_start - init_loop_start) + 1
        new_loop_end =
        ubf + (init_loop_end - selection_start) + 1
    elseif
      init_loop_end >= selection_end and
      init_loop_start < selection_start and
      selection_start - init_loop_start < ubf
      then
        new_loop_start =
        ubf - (selection_start - init_loop_start) + 1
        new_loop_end =
        ubf + (selection_end - selection_start) + 1               
      else
        new_loop_start = 1
        new_loop_end =
        ubf + (selection_end - selection_start) + 1        
      end
  new_sample.loop_start
  = new_loop_start
  new_sample.loop_end
  = new_loop_end
end

-- Add new sample 
function set_new_with_upbeat (upbeat)
  get_init_env()
  not_sliced_ok ()
  create_new (frames_with_upbeat(upbeat))   
  
  local s = upbeat_start_point(upbeat)
  local new_num_frames = frames_with_upbeat(upbeat)
  
  new_buffer:prepare_sample_data_changes()
  
  if s > 0
  then          
      for ch = 1,init_number_of_channels do
        for fr = 1,new_num_frames do
          new_buffer
          :set_sample_data(ch,fr,
           init_buffer:sample_data(ch, fr+s-1))
        end
      end
    else
      
      for ch = 1,init_number_of_channels do
        for fr = 1,(-s) do
          new_buffer:set_sample_data(
            ch,fr,
            0)
        end
        for fr = (1-s),new_num_frames do
          new_buffer
          :set_sample_data(ch,fr,
            init_buffer
            :sample_data(ch,fr+s))
        end
      end
    end
  new_buffer:finalize_sample_data_changes()
  set_new_loop_replace (upbeat)   
end


-- reset the selection range
function set_end_point (beat)
  get_init_env()
  not_sliced_ok ()
  local bt_frame = frames_per_xbeat (beat)
  local end_point = selection_start + bt_frame -1

  if bt_frame <= 0
    then renoise.app():show_error('Enter the number greater than zero')
  elseif
    end_point <= init_number_of_frames
    then
    init_buffer.selection_end  = end_point
  elseif
    end_point > init_number_of_frames
    then
    create_new (end_point)

    new_buffer:prepare_sample_data_changes()

      for ch = 1,init_number_of_channels do
        for fr = 1,init_number_of_frames do
          new_buffer
          :set_sample_data(
            ch,fr,
            init_buffer
            :sample_data(ch,fr))
        end
        for fr = init_number_of_frames+1,end_point do
          new_buffer
          :set_sample_data(
            ch,fr,0)
        end
      end      
      new_buffer:finalize_sample_data_changes()
      
      new_sample.loop_start
      = init_loop_start
      new_sample.loop_end
      = init_loop_end        

      init_sample:copy_from(new_sample)
      init_inst:delete_sample_at(init_sample_index + 1)
      init_buffer.selection_start = selection_start

  else return nil
  end
end

-- reset selection end with frame(sample)
function selection_frames ()
   local t = get_init_env()
  if t ~= true then return 0
  end
   local val
     val = selection_end - selection_start +1
   return val
end

function set_end_point_with_frame (frame)
  get_init_env()
  not_sliced_ok ()
  local end_point = selection_start + frame -1

  if frame <= 0
    then renoise.app():show_error('Enter the number greater than zero')
  elseif
    end_point <= init_number_of_frames
    then
    init_buffer.selection_end  = end_point
  elseif
    end_point > init_number_of_frames
    then
    create_new (end_point)
    new_buffer:prepare_sample_data_changes()
      for ch = 1,init_number_of_channels do
        for fr = 1,init_number_of_frames do
          new_buffer
          :set_sample_data(
            ch,fr,
            init_buffer
            :sample_data(ch,fr))
        end
        for fr = init_number_of_frames+1,end_point do
          new_buffer
          :set_sample_data(
            ch,fr,0)
        end
      end      
      new_buffer:finalize_sample_data_changes()
      
      new_sample.loop_start
      = init_loop_start
      new_sample.loop_end
      = init_loop_end        

      init_sample:copy_from(new_sample)
      init_inst:delete_sample_at(init_sample_index + 1)
      init_buffer.selection_start = selection_start
  else return nil
  end
end



-- sweep_ins()の際のLOOP位置再計算。
function set_new_loop_sweep ()
  local new_loop_start
  local new_loop_end
  if
    -- ss se ls le
    init_loop_start >= selection_end
    then
      new_loop_start =
      (selection_end - selection_start +1) +
      init_loop_start
      new_loop_end =
     (selection_end - selection_start +1) +
      init_loop_end
      
    elseif
      -- ss ls se le
      init_loop_start >= selection_start and
      init_loop_start <= selection_end and
      init_loop_end >= selection_end 
    then
      new_loop_start =
      (init_loop_start - selection_start +1) +
      selection_end
      new_loop_end =
      (selection_end - selection_start +1) +
      init_loop_end 
      
    elseif
      -- ss ls le se
      init_loop_start >= selection_start and
      init_loop_start <= selection_end and      
      init_loop_end <= selection_end 
    then
      new_loop_start =
      (init_loop_start - selection_start +1) +
      selection_end      
      new_loop_end =
      (init_loop_end - selection_start +1) +
      selection_end        
      
    elseif
      -- ls ss se le
      init_loop_start <= selection_start and
      init_loop_end >= selection_end
    then
      new_loop_start = init_loop_start
      new_loop_end =
      (selection_end - selection_start +1) +
      init_loop_end
      
    elseif
      -- ls ss le se
      init_loop_start <= selection_start and
      init_loop_end >= selection_start and
      init_loop_end <= selection_end    
    then
      new_loop_start = init_loop_start
      new_loop_end =
      (init_loop_end - selection_start +1) +
      selection_end        
    elseif
      -- ls le ss se
      init_loop_end <= selection_start
    then
      new_loop_start = init_loop_start
      new_loop_end = init_loop_end
      
    else
      return nil
    end
  new_sample.loop_start
  = new_loop_start
  new_sample.loop_end
  = new_loop_end  
end


function sweep_ins()
  get_init_env()
  not_sliced_ok ()
  
  local range = selection_end - selection_start +1
  if range == init_number_of_frames
  then return nil
  else
    local end_point = init_number_of_frames + range
    
    create_new (end_point)
      
    new_buffer:prepare_sample_data_changes()
    
        for ch = 1,init_number_of_channels do
          for fr = 1,selection_start -1 do
            new_buffer
            :set_sample_data(
              ch,fr,
              init_buffer
              :sample_data(ch,fr))
          end
          for fr = selection_start ,selection_end do
            new_buffer
            :set_sample_data(
              ch,fr,0)
          end
          for fr = selection_end +1,end_point do
            new_buffer
            :set_sample_data(
              ch,fr,
              init_buffer
              :sample_data(ch,fr-range))
          end        
        end      
    new_buffer:finalize_sample_data_changes()
    set_new_loop_sweep ()
    
    init_sample:copy_from(new_sample)
    init_inst:delete_sample_at(init_sample_index + 1)
    init_buffer.selection_start = selection_start
    init_buffer.selection_end = selection_end
  end
end


-- sync_del()の際のLOOP位置再計算。
function set_new_loop_del ()
  local new_loop_start
  local new_loop_end
  if
    -- ss se ls le
    init_loop_start >= selection_end
    then
      new_loop_start =
      (init_loop_start - selection_end) +
      selection_start -1
      new_loop_end =
      (init_loop_end - selection_end) +
      selection_start -1
     
    elseif
      -- ss ls se le
      init_loop_start >= selection_start and
      init_loop_start <= selection_end and
      init_loop_end >= selection_end 
    then
      new_loop_start = selection_start -1
      new_loop_end =
      (init_loop_end - selection_end) +
      selection_start -1
      
    elseif
      -- ss ls le se
      init_loop_start >= selection_start and
      init_loop_start <= selection_end and      
      init_loop_end <= selection_end 
    then
      new_loop_start = selection_start
      new_loop_end = selection_start
      
    elseif
      -- ls ss se le
      init_loop_start <= selection_start and
      init_loop_end >= selection_end
    then
      new_loop_start = init_loop_start
      new_loop_end =
      (init_loop_end - selection_end) +
      selection_start -1
      
    elseif
      -- ls ss le se
      init_loop_start <= selection_start and
      init_loop_end >= selection_start and
      init_loop_end <= selection_end    
    then
      new_loop_start = init_loop_start
      new_loop_end = selection_start -1
      
    elseif
      -- ls le ss se
      init_loop_end <= selection_start
    then
      new_loop_start = init_loop_start
      new_loop_end = init_loop_end
      
    else
      return nil
    end
  if new_loop_start <= 1
  then new_loop_start = 1
  end
  new_sample.loop_start
  = new_loop_start
  new_sample.loop_end
  = new_loop_end  
end



function sync_del()
  get_init_env()
  not_sliced_ok ()
  
  local range = selection_end - selection_start +1
  if range < 1 or
    range >= init_number_of_frames
  then return nil
  else
      local end_point = init_number_of_frames - range
    
      create_new (end_point)
      
      new_buffer:prepare_sample_data_changes()
    
          for ch = 1,init_number_of_channels do
            for fr = 1,selection_start -1 do
              new_buffer
              :set_sample_data(
                ch,fr,
                init_buffer
                :sample_data(ch,fr))
            end
            for fr = selection_start,end_point do
              new_buffer
              :set_sample_data(
                ch,fr,
                init_buffer
                :sample_data(ch,fr+range))
            end        
          end      
    new_buffer:finalize_sample_data_changes()
    set_new_loop_del ()
    
    init_sample:copy_from(new_sample)
    init_inst:delete_sample_at(init_sample_index + 1)
    if (selection_end -1) >= init_number_of_frames
      or selection_start < 2
    then return nil
    else
      init_buffer.selection_start = selection_start
      init_buffer.selection_end = selection_start 
    end
  end
end


